Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # |
Junio C Hamano | ae2b0f1 | 2005-11-24 00:12:11 -0800 | [diff] [blame] | 3 | # This is included in commands that either have to be run from the toplevel |
| 4 | # of the repository, or with GIT_DIR environment variable properly. |
| 5 | # If the GIT_DIR does not look like the right correct git-repository, |
| 6 | # it dies. |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 7 | |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 8 | # Having this variable in your environment would break scripts because |
Junio C Hamano | e598c51 | 2007-09-15 16:32:23 -0700 | [diff] [blame] | 9 | # you would cause "cd" to be taken to unexpected places. If you |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 10 | # like CDPATH, define it for your interactive shell sessions without |
| 11 | # exporting it. |
| 12 | unset CDPATH |
| 13 | |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 14 | die() { |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 15 | echo >&2 "$@" |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 16 | exit 1 |
| 17 | } |
| 18 | |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 19 | if test -n "$OPTIONS_SPEC"; then |
| 20 | usage() { |
Junio C Hamano | 5d29275 | 2007-12-20 12:58:06 -0800 | [diff] [blame] | 21 | "$0" -h |
| 22 | exit 1 |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 23 | } |
| 24 | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 25 | parseopt_extra= |
| 26 | [ -n "$OPTIONS_KEEPDASHDASH" ] && |
| 27 | parseopt_extra="--keep-dashdash" |
| 28 | |
| 29 | eval "$( |
Junio C Hamano | cbea86f | 2007-11-07 23:04:38 -0800 | [diff] [blame] | 30 | echo "$OPTIONS_SPEC" | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 31 | git rev-parse --parseopt $parseopt_extra -- "$@" || |
| 32 | echo exit $? |
| 33 | )" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 34 | else |
| 35 | usage() { |
| 36 | die "Usage: $0 $USAGE" |
| 37 | } |
| 38 | |
| 39 | if [ -z "$LONG_USAGE" ] |
| 40 | then |
| 41 | LONG_USAGE="Usage: $0 $USAGE" |
| 42 | else |
| 43 | LONG_USAGE="Usage: $0 $USAGE |
| 44 | |
| 45 | $LONG_USAGE" |
| 46 | fi |
| 47 | |
| 48 | case "$1" in |
| 49 | -h|--h|--he|--hel|--help) |
| 50 | echo "$LONG_USAGE" |
| 51 | exit |
| 52 | esac |
| 53 | fi |
Fredrik Kuivinen | d025524 | 2005-12-11 10:55:49 +0100 | [diff] [blame] | 54 | |
Shawn O. Pearce | f947413 | 2006-12-28 02:34:48 -0500 | [diff] [blame] | 55 | set_reflog_action() { |
| 56 | if [ -z "${GIT_REFLOG_ACTION:+set}" ] |
| 57 | then |
| 58 | GIT_REFLOG_ACTION="$*" |
| 59 | export GIT_REFLOG_ACTION |
| 60 | fi |
| 61 | } |
| 62 | |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 63 | git_editor() { |
David Kastrup | 0887465 | 2007-08-01 23:47:20 +0200 | [diff] [blame] | 64 | : "${GIT_EDITOR:=$(git config core.editor)}" |
| 65 | : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}" |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 66 | case "$GIT_EDITOR,$TERM" in |
| 67 | ,dumb) |
| 68 | echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL," |
| 69 | echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb." |
| 70 | echo >&2 "Please set one of these variables to an appropriate" |
| 71 | echo >&2 "editor or run $0 with options that will not cause an" |
| 72 | echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)." |
| 73 | exit 1 |
| 74 | ;; |
| 75 | esac |
David Kastrup | 0887465 | 2007-08-01 23:47:20 +0200 | [diff] [blame] | 76 | eval "${GIT_EDITOR:=vi}" '"$@"' |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 77 | } |
| 78 | |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 79 | is_bare_repository () { |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 80 | git rev-parse --is-bare-repository |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 81 | } |
| 82 | |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 83 | cd_to_toplevel () { |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 84 | cdup=$(git rev-parse --show-cdup) |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 85 | if test ! -z "$cdup" |
| 86 | then |
| 87 | cd "$cdup" || { |
| 88 | echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree" |
| 89 | exit 1 |
| 90 | } |
| 91 | fi |
| 92 | } |
| 93 | |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 94 | require_work_tree () { |
Johannes Schindelin | e90fdc3 | 2007-08-01 01:30:14 +0100 | [diff] [blame] | 95 | test $(git rev-parse --is-inside-work-tree) = true || |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 96 | die "fatal: $0 cannot be used without a working tree." |
| 97 | } |
| 98 | |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 99 | get_author_ident_from_commit () { |
| 100 | pick_author_script=' |
| 101 | /^author /{ |
| 102 | s/'\''/'\''\\'\'\''/g |
| 103 | h |
| 104 | s/^author \([^<]*\) <[^>]*> .*$/\1/ |
| 105 | s/'\''/'\''\'\'\''/g |
| 106 | s/.*/GIT_AUTHOR_NAME='\''&'\''/p |
| 107 | |
| 108 | g |
| 109 | s/^author [^<]* <\([^>]*\)> .*$/\1/ |
| 110 | s/'\''/'\''\'\'\''/g |
| 111 | s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p |
| 112 | |
| 113 | g |
| 114 | s/^author [^<]* <[^>]*> \(.*\)$/\1/ |
| 115 | s/'\''/'\''\'\'\''/g |
| 116 | s/.*/GIT_AUTHOR_DATE='\''&'\''/p |
| 117 | |
| 118 | q |
| 119 | } |
| 120 | ' |
| 121 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 077b725 | 2008-02-13 13:13:21 -0800 | [diff] [blame] | 122 | git show -s --pretty=raw --encoding="$encoding" "$1" -- | |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 123 | LANG=C LC_ALL=C sed -ne "$pick_author_script" |
| 124 | } |
| 125 | |
Junio C Hamano | 22c9071 | 2007-12-12 17:34:30 -0800 | [diff] [blame] | 126 | # Make sure we are in a valid repository of a vintage we understand, |
| 127 | # if we require to be in a git repository. |
Christian Couder | 70087cd | 2007-12-15 05:57:28 +0100 | [diff] [blame] | 128 | if test -z "$NONGIT_OK" |
Fredrik Kuivinen | d025524 | 2005-12-11 10:55:49 +0100 | [diff] [blame] | 129 | then |
Lars Hjemli | 4d6d6d2 | 2008-02-18 11:44:19 +0100 | [diff] [blame] | 130 | GIT_DIR=$(git rev-parse --git-dir) || exit |
Junio C Hamano | 22c9071 | 2007-12-12 17:34:30 -0800 | [diff] [blame] | 131 | if [ -z "$SUBDIRECTORY_OK" ] |
| 132 | then |
Junio C Hamano | 22c9071 | 2007-12-12 17:34:30 -0800 | [diff] [blame] | 133 | test -z "$(git rev-parse --show-cdup)" || { |
| 134 | exit=$? |
| 135 | echo >&2 "You need to run this command from the toplevel of the working tree." |
| 136 | exit $exit |
| 137 | } |
Junio C Hamano | 22c9071 | 2007-12-12 17:34:30 -0800 | [diff] [blame] | 138 | fi |
| 139 | test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || { |
| 140 | echo >&2 "Unable to determine absolute path of git directory" |
| 141 | exit 1 |
David Kastrup | b2bc9a3 | 2007-08-11 15:36:28 +0200 | [diff] [blame] | 142 | } |
Junio C Hamano | 22c9071 | 2007-12-12 17:34:30 -0800 | [diff] [blame] | 143 | : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"} |
Fredrik Kuivinen | d025524 | 2005-12-11 10:55:49 +0100 | [diff] [blame] | 144 | fi |